
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java秘术：用枚举构建一个状态机 / iVAN</title>

    <meta name="description" content="Java秘术：用枚举构建一个状态机 原文链接   作者:Peter Lawrey    译者:陈振阳 综述 Java中的enum比其他的语言中的都强大,这产生了很多令人惊讶的用法.本文中,我将列出Java中的enum的一些特性,然后将这些特性应用到一起构成一个状态机. Enum的单例和工具类用法 你可以非常简单地用一个enum构建一个单例或者工具类. &lt;/pre&gt; enum Singleton { INSTANCE; } enum Utility { ; // no instances } 用enum实现一个接口 你也 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java秘术：用枚举构建一个状态机</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><a href="http://www.javacodegeeks.com/2011/07/java-secret-using-enum-to-build-state.html" rel="external nofollow noreferrer">原文链接</a>   作者：Peter Lawrey    译者：陈振阳</p>
<h2>综述</h2>
<p>Java中的enum比其他的语言中的都强大，这产生了很多令人惊讶的用法。本文中，我将列出Java中的enum的一些特性，然后将这些特性应用到一起构成一个状态机。</p>
<h2>Enum的单例和工具类用法</h2>
<p>你可以非常简单地用一个enum构建一个单例或者工具类。</p>
<pre><code>&lt;/pre&gt;
enum Singleton {
    INSTANCE;
}
enum Utility {
    ; // no instances
}</code></pre>
<h2>用enum实现一个接口</h2>
<p>你也可以在一个enum中实现一个接口。</p>
<pre><code>interface Named {
    public String name();
    public int order();
}
enum Planets implements Named {
    Mercury, Venus, Earth, Mars, Jupiter, Saturn, Uranus, Neptune;
    // name() is implemented automagically.
    public int order() { return ordinal()+1; }
}</code></pre>
<h3>每一个enum实例，一个不同的子类</h3>
<p>你可以重载一个enum实例的方法。这将高效的给一个enum的实例一个自己的实现。</p>
<pre><code>// from http://download.oracle.com/javase/1,5.0/docs/guide/language/enums.html
public enum Operation {
  PLUS   { double eval(double x, double y) { return x + y; } },
  MINUS  { double eval(double x, double y) { return x - y; } },
  TIMES  { double eval(double x, double y) { return x * y; } },
  DIVIDE { double eval(double x, double y) { return x / y; } };

  // Do arithmetic op represented by this constant
  abstract double eval(double x, double y);
}</code></pre>
<h2>使用一个enum实现一个状态机</h2>
<p>用上边的技术，你可以做的是创建一个基于状态的enum。</p>
<p>在这个小例子中，解析器的状态机处理一个ByteBuffer里的原始的XML。每一个状态都有自己的处理方法，如果没有足够的可用的数据，状态机可以回来再次获取更多的数据。状态之间的每一次变换都被定义，所有状态的代码在一个enum中。</p>
<pre><code>interface Context {
    ByteBuffer buffer();
    State state();
    void state(State state);
}
interface State {
    /**
       * @return true to keep processing, false to read more data.
     */
    boolean process(Context context);
}
enum States implements State {
    XML {
        public boolean process(Context context) {
            if (context.buffer().remaining() &lt; 16) return false;
            // read header
            if(headerComplete)
                context.state(States.ROOT);
            return true;
        }
    }, ROOT {
        public boolean process(Context context) {
            if (context.buffer().remaining() &lt; 8) return false;
            // read root tag
            if(rootComplete)
                context.state(States.IN_ROOT);
            return true;
        }
    }
}

public void process(Context context) {
    socket.read(context.buffer());
    while(context.state().process(context));
}</code></pre>
<p>使用这种方式，可以创建一个XML解析器，解析器可以在10微秒内处理完数据包。大多数情况下，它跟你需要的一样高效。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-26 15:15:30</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java秘术：用枚举构建一个状态机的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj753WM.html" rel="bookmark">Java理论与实践&colon; 构建一个更好的HashMap</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ConcurrentHashMap 是 Doug Lea的 util.concurrent 包的一部分,它提供 比Hashtable 或者 synchronizedMap 更高程度的并发性.而且,对于大多数成 功的 get() 操作它会设法避免完全锁定,其结果就是使得并发应用程序有着非 常好的吞吐量.这个月,BrianGoetz 仔细分析了 ConcurrentHashMap的代码, 并探讨 Doug Lea 是如何在不损失线程安全的情况下取得这么骄人成绩的. 在7月份的那期 Java理论与实践			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1l9GKb.html" rel="bookmark">云效公有云如何构建一个基于Composer的PHP项目</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近在将公司的持续集成架构做一个系统的调整,调整过程中受到了云效公有云团队大量的帮助,分享这篇内容希望能让更多的人了解和用好这个产品. 我会把我最近3个月的使用体会分成5个部分:使用云效公有云的动机.PHP项目集成.JS项目集成.JAVA项目集成.Docker类项目集成这5个分支来写. 因为近期公有云的迭代比较频繁,所以我的分享会比较的浅,点到为止,仅供参考,目录: 1.云效公有云如何耦合进我们的业务 2.如何构建一个基于Composer的PHP项目 3.如何构建一个基于NodeJS的前后端项目			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN70Ryp.html" rel="bookmark">云效（原RDC）如何构建一个基于Composer的PHP项目</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近在将公司的持续集成架构做一个系统的调整,调整过程中受到了RDC团队大量的帮助,所以利用国庆时间写了几篇RDC的分享,希望能让更多的人了解和用好RDC这个产品. 我会把我最近3个月的使用体会分成5个部分:使用RDC的动机.PHP项目集成.JS项目集成.JAVA项目集成.Docker类项目集成这5个分支来写 因为近期RDC的迭代比较频繁,所以我的分享会比较的浅,点到为止,仅供参考,目录: 1.RDC如何耦合进我们的业务 2.如何构建一个基于Composer的PHP项目 3.如何构建一个基于Nod			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwxX2Ob.html" rel="bookmark">云效（原RDC）如何构建一个基于NodeJS的前后端项目</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近在将公司的持续集成架构做一个系统的调整,调整过程中受到了RDC团队大量的帮助,所以利用国庆时间写了几篇RDC的分享,希望能让更多的人了解和用好RDC这个产品. 我会把我最近3个月的使用体会分成5个部分:使用RDC的动机.PHP项目集成.JS项目集成.JAVA项目集成.Docker类项目集成这5个分支来写 因为近期RDC的迭代比较频繁,所以我的分享会比较的浅,点到为止,仅供参考,目录: 1.RDC如何耦合进我们的业务 2.如何构建一个基于Composer的PHP项目 3.如何构建一个基于Nod			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmVlmaz.html" rel="bookmark">java中的枚举类型详细介绍&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				枚举中有values方法用于按照枚举定义的顺序生成一个数组,可以用来历遍.我们自定义的枚举类都是继承自java.lang.Enum,拥有一下实例中的功能: 复制代码 代码如下: //: enumerated/EnumClass.java // Capabilities of the Enum class import static net.mindview.util.Print.*; enum Shrubbery { GROUND, CRAWLING, HANGING } public clas			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp5QBBp.html" rel="bookmark">Python中的线性优化，第 2 部分 在云中构建一个可扩展的基础架构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介 这个由三部分组成的系列文章的第 1 部分介绍了在 Python 中使用 Pyomo 库进行线性优化的 基础知识.现在我们将介绍如何扩展它.Python 缺乏真实的操作系统线程,该如何扩展它?本文将向您介绍 如何组合使用这些技术来创建一个实际的可扩展基础架构,该架构可用于构建一个 Pyomo Web 解决方案.我 们组合使用了一个单线程事件循环.一个 AMQP 服务器和工作线程流程来创建一个模式,利用该模式扩展一个 线性优化系统.该基础架构也适用于 Python 或 Ruby 中的许多通用计			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b24qBop.html" rel="bookmark">Java中的基础构建模块（第五章）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java中的基础构建模块 Java平台类库包含了丰富的并发基础构建模块,例如线程安全的容器类以及各种用于协调多个相互协作的线程控制流的同步工具类. 1.同步容器类 同步容器类都是线程安全的,但在某些情况下可能需要额外的客户端加锁来保护复合操作.常见的复合操作包括:迭代.跳转(在容器内元素之间).条件运算(例如&quot;若没有则添加&quot;). 隐式迭代:某些情况下迭代操作会隐藏起来.如下代码中println调用Set的toString方法,然后对Set中的对象进行迭代调用toString方法: pu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5onZ7b.html" rel="bookmark">《ANTLR 4权威指南》&mdash;&mdash;3&period;4　构建一个语言类应用程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3.4 构建一个语言类应用程序 我们继续完成能够处理数组初始化语句的示例程序,下一个目标是能够翻译初始化语句,而不仅仅是能够识别它们.例如,我们想要将Java中,类似{ 99, 3, 451 }的short数组翻译成&quot;\u0063\u0003\u01c3&quot;.注意,其中十进制数字99的十六进制表示是63. 为了完成这项工作,程序必须能够从语法分析树中提取数据.最简单的方案是使用ANTLR内置的语法分析树遍历器进行深度优先遍历,然后在它触发的一系列回调函数中进行适当的操作.正如我们之前看到			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWwXVp.html" rel="bookmark">全面解读Java中的枚举类型enum的使用&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于枚举大多数地方写的枚举都是给一个枚举然后例子就开始switch,可是我想说,我代码里头来源的数据不太可能就是枚举,通常是字符串或数字,比如一个SQL我解析后首先判定SQL类型,通过截取SQL的token,截取出来可能是SELECT.DELETE.UPDATE.INSERT.ALTER等等,但是都是字符串,此时我想用枚举就不行了,我要将字符串转换成枚举怎么转呢,类似的情况还有从数据库取出数据根据一些类型做判定,从页面传入数据,根据不同的类型做不同的操作,但是都是字符串,不是枚举,悲剧的是我很少			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5dmMn.html" rel="bookmark" class="title">win7电脑上＂我最近的文档＂显示为空的原因</a>
					<div>
						电脑总是会记录我们平常操作电脑打开的一些文档.一般来说我们浏览过的文档历史记录会在我最近的文档列表中看到,不过有时也会遇到最近的文档的列表显示为空,最近的文档浏览的历史记录都不存在了,那该怎么解决呢? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDwNKp.html" rel="bookmark" class="title">HTML5的Web应用程序</a>
					<div>
						本文来自:html5tutorial.net,由于英文水平太差,翻译不到位的地方请谅解. 我非常高兴HTML5教程的人们给了我这个机会向你们介绍我们公司开发的基于HTML5的model viewer应 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJxo2M.html" rel="bookmark" class="title">CSS 标签属性&sol;属性参考</a>
					<div>
						css|参考 这里列出了目前支持的样式表(CSS)标签属性.标有星号(*)的标签属性可于 Microsoft Internet Explorer 5 中使用.标有两个星号(**)的标签属性可于 Int ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8D2lp.html" rel="bookmark" class="title">绿萝无情谈链接中介平台如何生存</a>
					<div>
						从阿里微微被K站,再到站长网关闭链接交易平台,等等几大链接交易平台被无情的惩罚了.难道链接中介市场真的从此退出历史舞台?彻底消亡了?据笔者所知绿萝算法主要打击的对象还是这些链接中介,但许多小型的链接交 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2vkkb.html" rel="bookmark" class="title">八个方面来判断交换的友情链接是否划算</a>
					<div>
						友情链接是外链建设中最重要的一个,一般每个网站都有个专门交换友链链接的人员,每天都要交换1.2个,来逐步稳定的增加网站的权重和排名,甚至有些网站专门出高价去购买一些高权重网站的链接,来快速提升网站的权 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpd90mz.html" rel="bookmark" class="title">c&num;重点知识详解（四）</a>
					<div>
						详解 第四章:C# 中的加框与去框 C# 运行时中有两种类型:引用类型(reference)(在 C# 中用类声明)和值类型(value)(在 C# 中用结构声明).引用和值类型在几个重要方面有所不同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqL882b.html" rel="bookmark" class="title">Play框架（四） 表单</a>
					<div>
						表单(form)是最常见的从客户往服务器传递数据的方式.Play框架提供了一些工具.它们可以从表单中提取数据,验证提交数据的合法性,或者在视图中显示表单.我先来介绍最简单的使用表单提交数据的方式. 增 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91g4kM.html" rel="bookmark" class="title">Dreamweaver删除站点方法</a>
					<div>
						  首先打开dreamweaver,在菜单栏中找到&quot;站点&quot;--&quot;管理站点&quot;,如下图所示. 打开&quot;管理站点&quot;对话框,我们可以选择需要修改的站点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxQZkb.html" rel="bookmark" class="title">详解AngularJS中的依赖注入机制</a>
					<div>
						  这篇文章主要介绍了详解AngularJS中的依赖注入机制,对JavaScript各组件的使用起到非常重要的作用,需要的朋友可以参考下 依赖注入是一个在组件中给出的替代了硬的组件内的编码它们的依赖关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOnXvM.html" rel="bookmark" class="title">SQL Server的排序规则&lpar;collation&rpar;冲突和解决方案</a>
					<div>
						  什么是排序规则(collation) 关于SQL Server的排序规则,估计大家都不陌生,在创建数据库时我们经常要选择一种排序规则(conllation),一般我们会留意到每一种语言的排序规则都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yKgZz.html" rel="bookmark" class="title">PS的奥妙-照片的二次创作</a>
					<div>
						cs的强大功能,不只是用来修饰相片,二次创意才显示出它的强大威力.最近去广州小 洲村拍片,交上了一位雕塑家朋友.在我们交谈中,他和我谈了很多有关艺术的流派.写实. 写意.前卫.抽象等等.回来整理片子时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNmgoM.html" rel="bookmark" class="title">Win7系统下快速删除开机登录密码的方法</a>
					<div>
						  现在大家对于网络安全意识真是越来越重视了,几乎所有的私人电脑.手机都设置了开机密码,只有知道密码的人才可以登入成功,这对于文件的安全性得到了有力的保障,但是每一次开机都要输入密码也是件很麻烦的事情 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7yY7M.html" rel="bookmark" class="title">Everything如何快速搜索硬盘文件名</a>
					<div>
						  1.软件安装完成之后,点击桌面图标打开程序 2.程序如下图所示,程序正在检索硬盘请耐心等待.,依据硬盘文件数量多少时间可能稍长, 3.检索完成之后出现文件及文件夹列表 4.我们要搜索什么直接在输入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLm098z.html" rel="bookmark" class="title">《Adobe InDesign CS6中文版经典教程》目录&mdash;导读</a>
					<div>
						内容提要 Adobe InDesign CS6中文版经典教程 本书是畅销丛书&quot;经典教程&quot;之一,为读者学习Adobe InDesign CS6提供了最快速.最轻松.最系统的途径.&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QkY6p.html" rel="bookmark" class="title">php代码嵌入在html中，正确解析不了</a>
					<div>
						问题描述 php代码嵌入在html中,正确解析不了 我刚学php,已经搭建了Apache服务器,php也能正常显示.代码如下: 执行完后,显示结果如下: 查了资料说是,服务器搭建错误,解析不了php代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmGlAb.html" rel="bookmark" class="title">MySQL5&period;7 GTID 浅析</a>
					<div>
						GTID 简介 GTID (global transaction identifier)在MySQL5.6时引入,GTID是事务的全局唯一标识.GTID结构如下 GTID = source_id:tr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYY9Pp.html" rel="bookmark" class="title">c&num; winform-VS2013下C&num;程序运行第一次错误，第二次正常</a>
					<div>
						问题描述 VS2013下C#程序运行第一次错误,第二次正常 编译成功后的程序,第一次启动时会弹出窗口&quot;The operation could not be completed.另一个程序正在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDKDGz.html" rel="bookmark" class="title">竖线-求高手解答：vc2008中鼠标选中一个对象后跳出一些东西，如图</a>
					<div>
						问题描述 求高手解答:vc2008中鼠标选中一个对象后跳出一些东西,如图 那些东东是什么,竖线后面的数值又是什么,指针.地址.内容等等?改变数值会发生什么,如图 解决方案 就是这个对象的成员数据信息, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0VVYM.html" rel="bookmark" class="title">HTML5 Web Audio API实现【董小姐】播放</a>
					<div>
						论坛有人发了matlab实现的董小姐,于是想在自己熟悉的领域也试试看.之前用Python做过发出指定频率的声音,但是这个对第三方库的依赖较大.于是准备在JavaScript中实现. 先发一个不错的参考 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKNRYb.html" rel="bookmark" class="title">linux-makefile，下面命令的-D  &dollar;（date）表示什么意思呢？</a>
					<div>
						问题描述 makefile,下面命令的-D $(date)表示什么意思呢? %.o:%.c $(CC) -c $(CFLAGS) $(CPPFLAGS) -D $(date) 解决方案 http:// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRXB5b.html" rel="bookmark" class="title">六款常用的linux C&sol;C&plus;&plus; IDE</a>
					<div>
						摘要: 一.AnjutaAnjuta是一个多语言的IDE,它最大的特色是灵活,同时打开多个文件,内嵌代码级的调试器(调用gdb),应用程序向导(Application wizards)可以方便的帮助你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZvG7z.html" rel="bookmark" class="title">看完这些案例，你就能玩转大数据分析&excl;</a>
					<div>
						文章讲的是看完这些案例,你就能玩转大数据分析,如今我们处在一个人人谈论大数据的时代.为何大数据如此火爆?就是因为数据蕴含无限价值.而这个价值如何挖掘却是个费解的难题.一些企业已经意识到这一点,开始拥抱 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40x1qz.html" rel="bookmark" class="title">12306火车票监控代码&mdash;&mdash;Python（转）</a>
					<div>
						问题描述 找到一个12306火车票监控代码,如下import urllib.request as request import http.cookiejar as cookiejar import r ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlnm7p.html" rel="bookmark" class="title">做题吧！高手们！！</a>
					<div>
						问题描述 1.要想编写高效代码,必须掌握那一知识?A.编译原理 B.计算机体系结构 C.C语言2.从JSON.YAML等数据交换格式中,能够看出数据从结构上最终可分为几种类型?A.标量.数组.散列 B ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baB2ywM.html" rel="bookmark" class="title">swift字典转模型。。。。。</a>
					<div>
						问题描述 swift字典转模型..... 想把服务器请求回来的数据全部放进数组中,然后将这个字典数组转成模型数组,请问应该怎么写啊?现在卡在放进数组那里了 解决方案 http://www.open-o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPko0AM.html" rel="bookmark" class="title">台州一著名教育辅导机构老板卷款千万元潜逃</a>
					<div>
						昨天上午,不少学生家长收到匿名短信:西西里董事长洪邦云卷款潜逃,公司2000多万资产无法追回,现在http://www.aliyun.com/zixun/aggregation/30713.html& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNmJkPb.html" rel="bookmark" class="title">宗宁：公关经典案例，3B大战中的渠道压制</a>
					<div>
						记得曾经有一种说法,&quot;当体重差别超过60公斤的时候,格斗技巧将会失去作用&quot;.而在现实的比赛中,跨一个量级(2公斤左右)能获得胜利的情况都是非常了不起的,这实际上是对YY技巧取胜的p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZmZwYp.html" rel="bookmark" class="title">&lbrack;翻译&rsqb;初识SQL Server 2005 Reporting Services Part 4</a>
					<div>
						原文:[翻译]初识SQL Server 2005 Reporting Services Part 4 这一篇是关于SQL Server 2005 Reporting Services四篇文章中最后一篇 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Ye3wp.html" rel="bookmark" class="title">Android开发必备：秒杀真机超快模拟器Genymotion介绍&lowbar;Android</a>
					<div>
						第一,这货速度太快,第二,模仿真机环境,第三,秒杀任何Android模拟器包括真机,不多说上图,我忒忙! 官网: http://www.genymotion.com/ 镜像图片可以创建多个模拟器 关键 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQavOob.html" rel="bookmark" class="title">青岛啤酒：百年老号之跃</a>
					<div>
						青岛啤酒啤几岁了? 2003年,在百年华诞之际,青啤宣布将自己的百年历史归零,为成为&quot;一个拥有全球影响力品牌的国际化大公司&quot;的愿景重新出发. 青啤的新生,离不开其在品牌之路上的不断 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
